#version 120

#define NUM_BLURAMOUNT 4

uniform int Orientation; 
uniform int BlurAmount; 
uniform float BlurScale; 
uniform float BlurStrength; 
uniform float TexelSize; 

varying vec2 coords[NUM_BLURAMOUNT+1];
varying float amount[NUM_BLURAMOUNT+1];

float Gaussian (float x, float deviation) { 
	return (1.0 / sqrt(2.0 * 3.141592 * deviation)) * exp(-((x * x) / (2.0 * deviation))); 
} 

void main() {
	gl_Position = gl_Vertex;
    vec2 UV = gl_MultiTexCoord0.st;

	float halfBlur = float(BlurAmount) * 0.5; 
	float deviation = halfBlur * 0.35; 
	deviation *= deviation; 
	float strength = 1.0 - BlurStrength; 

	for ( int i=1; i<BlurAmount; ++i) {
		float offset = float(i) * TexelSize * BlurScale; 
		if (Orientation == 0) {
			coords[i] = vec2(offset, 0.0);
		} else {
			coords[i] = vec2(0.0, offset);
		}
		amount[i] = Gaussian(float(i) * strength, deviation);
	}
	coords[0]= UV;
	amount[0] = Gaussian(0, deviation);
}
